#include <stdio.h>
#include <stdlib.h>



/*  This code is an implementation of the slope one method  */

float predictions(int *ratings,int *denominator,float *deviation,int user,int item);
float weightedpredictions(int *ratings,int *denominator,float *deviation,int user,int item);

int main ( argc , argv )
int argc;
char **argv;
{

FILE *fpe;
fpe=fopen("u1.test","r");
if(fpe==NULL)
{
	printf("File (u1.test) could not be opened. \n");
	return -1;
}
int users;
printf("How many users are in the file? \n");
scanf("%i",&users);

int records;
printf("How many records has the txt file? \n");
scanf("%i",&records);

/* ###### Memory Allocation ###### */

int *ratings,*numerator,*denominator;
float *deviation;

ratings=(int *)calloc( users*1682 ,sizeof(int) );
if (ratings==NULL) {
printf("Memory allocaton for ratings failed \n");
}

numerator=(int*)calloc( users*1682*1682 ,sizeof(int) );
if(numerator==NULL) {
printf("Memory allocation for numerator failed \n");
}

denominator=(int*)calloc( 1682*1682 ,sizeof(int) );
if(denominator==NULL) {
printf("Memory allocation for denominator failed \n");
}

deviation=(float*)calloc( 1682*1682 ,sizeof(float) );
if(deviation==NULL) {
printf("Memory allocation for deviation failed \n");
}

/* ###### ------ ###### */

/* ###### Reading data from text file and set buffer ###### */

int user,item,rating,ts;
int buffer[records][3];
int i=0;
int j=1;
while(!feof(fpe)){
fscanf(fpe,"%i\t%i\t%i\t%i ",&user,&item,&rating,&ts);
//printf ("user= %i  item= %i rating= %i \n", user,item,rating);
buffer[i][0]=user;
buffer[i][1]=item;
buffer[i][2]=rating;
i++;
}
fclose(fpe);

/* ######  

//Print buffer 
for(i=0;i<records;i++) {
for(j=0;j<3;j++) {
printf("buffer[%i][%i]=%i  ",i,j,buffer[i][j]);
	 }
printf ("\n");
 }

###### */


/* ###### ------ ###### */

/* ###### Set Ratings ###### */

int testuser;
testuser=buffer[0][0];
int k=0;
int w=0;
int m=0;
for(i=0;i<records;i++) {
	if(buffer[i][0]==testuser){
			if(buffer[i][1]==j) {
				ratings[k]=buffer[i][2];
				}
			else {
				ratings[k]=0;
				i--;
				}
			j++;
		}
	else {
		testuser++;
		i--;
		j=1;
		k--;
		}
	k++;

}
/* ######  

//print ratings
printf("### Ratings ### \n");
k=0;
for(i=0;i<users;i++){
for(j=0;j<1682;j++) {
printf(" ratings[%i][%i]=%i \n",i+1,j+1,ratings[k]);
k++;
}
}

###### */

/* ###### ------ ###### */

/* ###### Set numerator(differences matrix) - denominator(frequencies matrix) ###### */
/* ###### Set deviation ###### */
k=0;
int l=0;
testuser=buffer[0][0];
int x=testuser-2;
for(testuser=buffer[0][0];testuser<=users;testuser++) {
	w=0;
	m=0;
	for(i=1;i<=1682;i++) {
		for(j=1;j<=1682;j++) {
		if(i==j){
			if( (ratings[x+i]==0) || (ratings[x+j]==0) ) {
			numerator[k]=10;
			}
			else {	
			numerator[k]=0;
			}
			k++;
			}
		else {  
			if( (ratings[x+i]==0) || (ratings[x+j]==0) ) {
			numerator[k]=10;
			}
			else {
			numerator[k]=ratings[x+i]-ratings[x+j];
			}
			k++;
			}
			//printf(" numerator[%i][%i][%i]=%i \t",testuser,i,j,numerator[k-1]);
			//calculate deviation's numerator	
			if(numerator[l]!=10){
			deviation[m]=deviation[m]+numerator[l];
			}
			m++;
			l++;
		}
	//printf("\n");	
	if( ratings[x+i]!=0 ) {
				w=w+i-1;
				denominator[w]=denominator[w]+1;
				w++;
				for(j=i+1;j<=1682;j++) {
					if( ratings[x+j]!=0 ) {
						denominator[w]=denominator[w]+1;
					}
				w++;
				}
			}
			else if (ratings[x+i]==0){
				w=w+i-1;
				w++;
				for(j=i+1;j<=1682;j++) {
				w++;
				}
			}	
	}
x=x+1682;
}


// calculate symmetric values of denominator
int z=0;
for(i=1;i<1682;i++){
	z=i*1682;
	denominator[z]=denominator[i];
	for(k=0;k<=i-1;k++){
		z++;
		denominator[z]=denominator[z-(i-1)*1681+(k*1681)];
	}
}

/* ######
//print denominator
printf("### Denominator (Frequencies) ### \n");
k=0;
	for(i=1;i<=1682;i++) {
		for(j=1;j<=1682;j++) {
				printf(" denominator[%i][%i]=%i \t",i,j,denominator[k]);
				k++;
				}
			printf("\n");
			}
###### */

/* ###### ------ ###### */

/* ###### Calculate Deviation ###### */



//print deviation
//printf("### Deviation ### \n");
k=0;
	for(i=1;i<=1682;i++) {
		for(j=1;j<=1682;j++) {
				//calculate deviation
				if(denominator[k]==0){
				deviation[k]=0;	
				}
				else{
				deviation[k]=deviation[k]/denominator[k];
				}
//				printf(" deviation[%i][%i]=%f \t",i,j,deviation[k]);
				k++;
				}
//			printf("\n");
			}


/* ###### ------ ###### */

/* ###### Predictions ###### */

float pred;
pred=predictions(ratings,denominator,deviation,1,5);
printf("The prediction for user 1 and item 5 is:%f \n",pred);
pred=predictions(ratings,denominator,deviation,5,427);
printf("The prediction for user 5 and item 427 is:%f \n",pred);
pred=weightedpredictions(ratings,denominator,deviation,5,3);
printf("The weighted prediction for user 5 and item 3 is:%f \n",pred);
pred=weightedpredictions(ratings,denominator,deviation,3,357);
printf("The weighted prediction for user 3 and item 357 is:%f \n",pred);


/* ###### ------ ###### */

free(ratings);
free(numerator);
free(denominator);
free(deviation);
return 0;

}
 

/* ###### Function Predictions ###### */

float predictions(int *ratings,int *denominator,float *deviation,int user,int item){

float prediction;
float u;
int count=0;
float sum=0;
int i=0;
int cardRi=0;
float Sdev=0;
int item2;
for(i=((user*1682)-1682);i<user*1682;i++){
	if(ratings[i]!=0){
		count++;
		sum=sum+ratings[i];
		u=sum/count;
		}
	}
if(ratings[(user*1682)+item-1683]==0){
	cardRi=count;
	}
	else{
	cardRi=count-1;
	}
for(item2=1;item2<=1682;item2++){
	if(item2!=item && ratings[user*1682+item2-1683]!=0 && denominator[(item-1)*1682+item2-1]!=0){
			Sdev=Sdev+deviation[(item-1)*1682+item2-1];
		}
	}
if(cardRi==0 || Sdev==0){
printf("Prediction not availiable for user %i and item %i \n",user,item);
}
else{
prediction=u+Sdev/cardRi;
}
return prediction;
}

/* ###### ------ ###### */

/* ###### Function Weighted Predictions ###### */

float weightedpredictions(int *ratings,int *denominator,float *deviation,int user,int item){

float prediction;
float S1=0;
int S2=0;
int item2;
for(item2=1;item2<=1682;item2++){
	if(item2!=item && ratings[user*1682+item2-1683]!=0 ){
			S1=S1+(deviation[(item-1)*1682+item2-1]+ratings[user*1682+item2-(1682+1)])*denominator[(item-1)*1682+item2-1];
			S2=S2+denominator[(item-1)*1682+item2-1];
		}
	}
if(S2==0){
printf("Prediction not availiable for user %i and item %i \n",user,item);
}
else{
prediction=S1/S2;
}
return prediction;
}

/* ###### ------ ###### */
