#include <stdio.h>
#include <stdlib.h>
#include <omp.h>


/*  This code is an implementation of the slope one method  */

#define ITEMS 1682
#define users 943
#define records 100000

float predictions(int *ratings,int *denominator,float *deviation,int user,int item);
float weightedpredictions(int *ratings,int *denominator,float *deviation,int user,int item);

int main ( argc , argv )
int argc;
char **argv;
{

/* ###### Variables fot time calculation ###### */
double t_start,t_end,t_calc_start,t_calc_end,t_IO_start,t_IO_end,pp_end,pred_time_start,pred_time_end,wpred_time_start,wpred_time_end;
double totaltime=0.0;
double calctime=0.0;
double IOtime=0.0;
double pptime=0.0;
double tpred=0.0;
double twpred=0.0;
double timeIO=0.0;
double timeIOw=0.0;

t_start=omp_get_wtime();
t_IO_start=omp_get_wtime();
FILE *fpe;
fpe=fopen("u.data","r");
if(fpe==NULL)
{
	printf("File u.data could not be opened. \n");
	return -1;
}
t_IO_end=omp_get_wtime();
IOtime=IOtime+t_IO_end-t_IO_start;
/* ###### Memory Allocation ###### */

int *ratings,*numerator,*denominator;
float *deviation;

ratings=(int *)calloc( users*ITEMS ,sizeof(int) );
if (ratings==NULL) {
printf("Memory allocaton for ratings failed \n");
}

numerator=(int*)calloc( ITEMS*ITEMS ,sizeof(int) );
if(numerator==NULL) {
printf("Memory allocation for numerator failed \n");
}

denominator=(int*)calloc( ITEMS*ITEMS ,sizeof(int) );
if(denominator==NULL) {
printf("Memory allocation for denominator failed \n");
}

deviation=(float*)calloc( ITEMS*ITEMS ,sizeof(float) );
if(deviation==NULL) {
printf("Memory allocation for deviation failed \n");
}

/* ###### ------ ###### */

/* ###### Reading data from text file and set buffer ###### */

int user,item,rating,ts;
int buffer[records][3];
int i=0;
int j=1;
t_IO_start=omp_get_wtime();
while(!feof(fpe)){
fscanf(fpe,"%i\t%i\t%i\t%i ",&user,&item,&rating,&ts);
//printf ("user= %i  item= %i rating= %i \n", user,item,rating);
buffer[i][0]=user;
buffer[i][1]=item;
buffer[i][2]=rating;
i++;
}
fclose(fpe);
t_IO_end=omp_get_wtime();
IOtime=IOtime+t_IO_end-t_IO_start;
/* ###### ------ ###### */
t_calc_start=omp_get_wtime();
/* ###### Set Ratings ###### */

int testuser;
int k=0;
int w=0;
int m=0;

#pragma omp parallel private(i,j,k,testuser)
{

#pragma omp for 
for(i=0;i<records;i++) {
	testuser=buffer[i][0];
	j=buffer[i][1];
	k=(testuser*ITEMS)-ITEMS+j-1;
	ratings[k]=buffer[i][2];
	}
} /* end of parallel section */

 /* ######  
//print ratings
printf("### Ratings ### \n");
k=0;
for(i=0;i<users;i++){
for(j=0;j<ITEMS;j++) {
printf(" ratings[%i][%i]=%i \n",i+1,j+1,ratings[k]);
k++;
}
}
 ###### */

/* ###### Set numerator(differences matrix) - denominator(frequencies matrix) ###### */
/* ###### Set deviation ###### */

int x=0;
int z=0;

#pragma omp parallel private(i,j,k,testuser,x,w,m,z) firstprivate(numerator)
{

#pragma omp for 
for(testuser=1;testuser<=users;testuser++) { 
x=(testuser-1)*ITEMS;
	k=0;
	w=0;
	m=0;
	for(i=1;i<=ITEMS;i++) {
		for(j=1;j<=ITEMS;j++) {
		if(i==j){
			if( (ratings[x+i-1]==0) || (ratings[x+j-1]==0) ) {
			numerator[k]=10;
			}
			else {	
			numerator[k]=0;
			}
			k++;
			}
		else {  
			if( (ratings[x+i-1]==0) || (ratings[x+j-1]==0) ) {
			numerator[k]=10;
			}
			else {
			numerator[k]=ratings[x+i-1]-ratings[x+j-1];
			}
			k++;
			}
//			printf(" numerator[%i][%i][%i]=%i \t",testuser,i,j,numerator[k-1]);
//			printf("testuser= %d x= %d i=%d j=%d k=%d \n",testuser,x,i,j,k);
			//calculate deviation's numerator	
			if(numerator[k-1]!=10){
			deviation[m]=deviation[m]+numerator[k-1];
			}
			m++;
			
		} //end for j
	
//	printf("\n");	
	if( ratings[x+i-1]!=0 ) {
				w=w+i-1;
				denominator[w]=denominator[w]+1;
				w++;
				for(j=i+1;j<=ITEMS;j++) {
					if( ratings[x+j-1]!=0 ) {
						denominator[w]=denominator[w]+1;
					}
				w++;
				}
			}
			else if (ratings[x+i-1]==0){
				w=w+i-1;
				w++;
				for(j=i+1;j<=ITEMS;j++) {
				w++;
				}
			}	
	}
	
	for(z=0;z<ITEMS*ITEMS;z++)
	{
		numerator[z]=0;
	}
			

}



// calculate symmetric values of denominator

#pragma omp for 
for(i=1;i<ITEMS;i++){
	z=i*ITEMS;
	denominator[z]=denominator[i];
	for(k=0;k<=i-1;k++){
		z++;
		denominator[z]=denominator[z-(i-1)*(ITEMS-1)+(k*(ITEMS-1))];
	}
}
/* ###### Calculate Deviation ###### */

//print deviation
//printf("### Deviation ### \n");
k=0;
#pragma omp for 
	for(i=1;i<=ITEMS;i++) {
	k=(i-1)*ITEMS;
		for(j=1;j<=ITEMS;j++) {
				//calculate deviation
				if(denominator[k]==0){
				deviation[k]=0;	
				}
				else{
				deviation[k]=deviation[k]/denominator[k];
				}
//				printf(" deviation[%i][%i]=%f \t",i,j,deviation[k]);
				k++;
				}
//			printf("\n");
			}


/* ###### ------ ###### */
} /* end of parallel section */
 pp_end=omp_get_wtime();
pptime=pp_end-t_start;
/* ###### Predictions ###### */

float pred;
//pred=predictions(ratings,denominator,deviation,1,5);
//printf("The prediction for user 1 and item 5 is:%f \n",pred);
//pred=predictions(ratings,denominator,deviation,5,427);
//printf("The prediction for user 5 and item 427 is:%f \n",pred);
//pred=weightedpredictions(ratings,denominator,deviation,5,3);
//printf("The weighted prediction for user 5 and item 3 is:%f \n",pred);
//pred=weightedpredictions(ratings,denominator,deviation,3,357);
//printf("The weighted prediction for user 3 and item 357 is:%f \n",pred);

/* ###### Create file predictions ###### */
t_IO_start=omp_get_wtime();
FILE *fp;
fp=fopen("predictions.txt","w");
if(fp==NULL)
{
	printf("File predictions could not be opened. \n");
	return -1;
}

fprintf(fp,"User\tItem\t Rating\n");
t_IO_end=omp_get_wtime();
IOtime=IOtime+t_IO_end-t_IO_start;
pred_time_start=omp_get_wtime();
#pragma omp parallel private(i,user,item) 
{
#pragma omp for 
for(i=0;i<users*ITEMS;i++)
{
	if(ratings[i]==0)
	{
		user=i/ITEMS+1;
		item=i%ITEMS+1;
		pred=predictions(ratings,denominator,deviation,user,item);
		t_IO_start=omp_get_wtime();
		fprintf(fp,"%d\t%d\t%f\n",user,item,pred);
		t_IO_end=omp_get_wtime();
		timeIO=timeIO+t_IO_end-t_IO_start;
		IOtime=IOtime+t_IO_end-t_IO_start;
	}
}
} /* end of parallel section */
pred_time_end=omp_get_wtime();
tpred=pred_time_end-pred_time_start-timeIO;
t_IO_start=omp_get_wtime();
fclose(fp);

/* ###### Create file weightedpredictions ###### */
FILE *fpw;
fpw=fopen("weightedpredictions.txt","w");
if(fpw==NULL)
{
	printf("File weightedpredictions could not be opened. \n");
	return -1;
}

fprintf(fpw,"User\tItem\t Rating\n");
t_IO_end=omp_get_wtime();
IOtime=IOtime+t_IO_end-t_IO_start;
wpred_time_start=omp_get_wtime();
#pragma omp parallel private(i,user,item) 
{
#pragma omp for 
for(i=0;i<users*ITEMS;i++)
{
	if(ratings[i]==0)
	{
		user=i/ITEMS+1;
		item=i%ITEMS+1;
		pred=weightedpredictions(ratings,denominator,deviation,user,item);
		t_IO_start=omp_get_wtime();
		fprintf(fpw,"%d\t%d\t%f\n",user,item,pred);
		t_IO_end=omp_get_wtime();
		timeIOw=timeIOw+t_IO_end-t_IO_start;
		IOtime=IOtime+t_IO_end-t_IO_start;
	}
}
} /* end of parallel section */
wpred_time_end=omp_get_wtime();
twpred=wpred_time_end-wpred_time_start-timeIOw;
t_IO_start=omp_get_wtime();
fclose(fpw);

t_IO_end=omp_get_wtime();
IOtime=IOtime+t_IO_end-t_IO_start;
t_calc_end=omp_get_wtime();
calctime=t_calc_end-t_calc_start-IOtime-tpred-twpred;
/* ###### ------ ###### */


/* ###### ------ ###### */
free(ratings);
free(numerator);
free(denominator);
free(deviation);
t_end=omp_get_wtime();
totaltime=t_end-t_start;
printf("Total execution time is %f seconds.\n",totaltime);
printf("Computation time is %f seconds.\n",calctime);
printf("IO time is %f seconds.\n",IOtime);
printf("Preprocess time is %f seconds.\n",pptime);
printf("Predictions time is %f seconds.\n",tpred);
printf("Weighted predictions time is %f seconds.\n",twpred);

return 0;

}
 
 
 /* ###### Function Predictions ###### */

float predictions(int *ratings,int *denominator,float *deviation,int user,int item){

float prediction;
float u;
int count=0;
float sum=0;
int i=0;
int cardRi=0;
float Sdev=0;
int item2;

#pragma omp parallel for default(none)  shared(user,ratings) \
		reduction(+:sum,count)  
for(i=((user*ITEMS)-ITEMS);i<user*ITEMS;i++){
	if(ratings[i]!=0){
		count++;
		sum=sum+ratings[i];
		}
	}
	
/* end of parallel  for section and reduction */
u=sum/count;	
if(ratings[(user*ITEMS)+item-(ITEMS+1)]==0){
	cardRi=count;
	}
	else{
	cardRi=count-1;
	}
#pragma omp parallel for default(none)  shared(user,deviation,ratings,denominator,item) \
		reduction(+:Sdev)  	
for(item2=1;item2<=ITEMS;item2++){
	if(item2!=item && ratings[user*ITEMS+item2-(ITEMS+1)]!=0 && denominator[(item-1)*ITEMS+item2-1]!=0){
			Sdev=Sdev+deviation[(item-1)*ITEMS+item2-1];
		}
	}
/* end of parallel  for section and reduction */	
if(cardRi==0 || Sdev==0){
//printf("Prediction not availiable for user %i and item %i \n",user,item);
}
else{
prediction=u+Sdev/cardRi;
}
return prediction;
}

/* ###### ------ ###### */

/* ###### Function Weighted Predictions ###### */

float weightedpredictions(int *ratings,int *denominator,float *deviation,int user,int item){

float prediction;
float S1=0;
int S2=0;
int item2;
#pragma omp parallel for default(none)  shared(user,deviation,ratings,denominator,item) \
		reduction(+:S1,S2) 
for(item2=1;item2<=ITEMS;item2++){
	if(item2!=item && ratings[user*ITEMS+item2-(ITEMS+1)]!=0 ){
			S1=S1+(deviation[(item-1)*ITEMS+item2-1]+ratings[user*ITEMS+item2-(ITEMS+1)])*denominator[(item-1)*ITEMS+item2-1];
			S2=S2+denominator[(item-1)*ITEMS+item2-1];
		}
	}
/* end of parallel  for section and reduction */	
if(S2==0){
//printf("Prediction not availiable for user %i and item %i \n",user,item);
}
else{
prediction=S1/S2;
}
return prediction;
}

/* ###### ------ ###### */
